## net.sf.saxon.value
Class Closure

    java.lang.Object
      net.sf.saxon.value.Value
          net.sf.saxon.value.Closure

All Implemented Interfaces:
  Expression, java.io.Serializable, ValueRepresentation

Direct Known Subclasses:
  MemoClosure

public class Closure
extends Value

A Closure represents a value that has not yet been evaluated: the value is represented by an expression, together with saved values of all the context variables that the expression depends on.

This Closure is designed for use when the value is only read once. If the value is read more than once, a new iterator over the underlying expression is obtained each time: this may (for example in the case of a filter expression) involve significant re-calculation.

The expression may depend on local variables and on the context item; these values are held in the saved XPathContext object that is kept as part of the Closure, and they will always be read from that object. The expression may also depend on global variables; these are unchanging, so they can be read from the Bindery in the normal way. Expressions that depend on other contextual information, for example the values of position(), last(), current(), current-group(), should not be evaluated using this mechanism: they should always be evaluated eagerly. This means that the Closure does not need to keep a copy of these context variables.

See Also:
  Serialized Form

Field Summary
`protected int` `depth`
`protected Expression` `expression`
`protected SequenceIterator` `inputIterator`
`protected XPathContextMajor` `savedXPathContext`

Fields inherited from interface net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`protected` `Closure()` Private constructor: instances must be created using the make() method

Method Summary
`void` `display(int level, NamePool pool, java.io.PrintStream out)` Convert to Java object (for passing to external functions)
`int` `getCardinality()` Get the cardinality
`int` `getImplementationMethod()` An implementation of Expression must provide at least one of the methods evaluateItem(), iterate(), or process().
`ItemType` `getItemType()` Get the static item type
`int` `getSpecialProperties()` Get the static properties of this expression (other than its type).
`SequenceIterator` `iterate(XPathContext context)` Evaluate the expression in a given context to return an iterator over a sequence
`static Value` `make(Expression expression, XPathContext context, boolean save)` Construct a Closure by supplying the expression and the set of context variables.
`void` `process(XPathContext context)` Process the instruction, without returning any tail calls

Methods inherited from class net.sf.saxon.value.Value
`analyze, asItem, asValue, checkPermittedContents, collapseWhitespace, convert, convertJavaObjectToXPath, convertToJava, effectiveBooleanValue, equals, evaluateAsString, evaluateItem, getDependencies, getIterator, getLength, getParentExpression, getStringValue, hashCode, itemAt, iterateSubExpressions, makeQNameValue, normalizeWhitespace, promote, simplify, stringToNumber, toString, trimWhitespace`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### expression

    protected Expression expression

### savedXPathContext

    protected XPathContextMajor savedXPathContext

### depth

    protected int depth

### inputIterator

    protected SequenceIterator inputIterator

Constructor Detail

### Closure

    protected Closure()

  Private constructor: instances must be created using the make() method

Method Detail

### make

    public static Value make(Expression expression,
                             XPathContext context,
                             boolean save)
                      throws XPathException

  Construct a Closure by supplying the expression and the set of context variables.

  Throws:
    `XPathException`

### getItemType

    public ItemType getItemType()

  Get the static item type

  Specified by:
    `getItemType` in interface `Expression`
  Overrides:
    `getItemType` in class `Value`
  Returns:
    AnyItemType (not known)

### getCardinality

    public int getCardinality()

  Get the cardinality

  Specified by:
    `getCardinality` in interface `Expression`
  Overrides:
    `getCardinality` in class `Value`

### getSpecialProperties

    public int getSpecialProperties()

  Get the static properties of this expression (other than its type). The result is bit-signficant. These properties are used for optimizations. In general, if property bit is set, it is true, but if it is unset, the value is unknown.

  Specified by:
    `getSpecialProperties` in interface `Expression`
  Overrides:
    `getSpecialProperties` in class `Value`
  Returns:
    `StaticProperty.NON_CREATIVE`

### getImplementationMethod

    public int getImplementationMethod()

  An implementation of Expression must provide at least one of the methods evaluateItem(), iterate(), or process(). This method indicates which of these methods is provided. This implementation provides both iterate() and process() methods natively.

### iterate

    public SequenceIterator iterate(XPathContext context)
                             throws XPathException

  Evaluate the expression in a given context to return an iterator over a sequence

  Parameters:
    `context` - the evaluation context. This is ignored; we use the context saved as part of the Closure instead.
  Returns:
    a SequenceIterator that can be used to iterate over the result of the expression
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### process

    public void process(XPathContext context)
                 throws XPathException

  Process the instruction, without returning any tail calls

  Specified by:
    `process` in interface `Expression`
  Overrides:
    `process` in class `Value`
  Parameters:
    `context` - The dynamic context, giving access to the current node, the current variables, etc.
  Throws:
    `XPathException`

### display

    public void display(int level,
                        NamePool pool,
                        java.io.PrintStream out)

  Convert to Java object (for passing to external functions)

  Specified by:
    `display` in interface `Expression`
  Overrides:
    `display` in class `Value`